'use server';
import { NextResponse } from 'next/server';
import { GraphQLClient, gql } from 'graphql-request';
import { buildTypesAddSchema } from './schema';

const endpoint = "http://localhost:3001/graphql";

export async function POST(request: Request) {
    const body = await request.json();
    const validatedBody = buildTypesAddSchema.parse(body);
    try {
        const client = new GraphQLClient(endpoint);
        const query = gql`
            mutation CreateBuildAddress($input: CreateBuildAddressInput!) {
                createBuildAddress(input: $input) {
                    _id
                    buildNumber
                    doorNumber
                    floorNumber
                    commentAddress
                    letterAddress
                    shortLetterAddress
                    latitude
                    longitude
                    street
                }
            }
        `;
        const variables = { input: validatedBody };
        const data = await client.request(query, variables);
        return NextResponse.json({ data: data.createBuildAddress, status: 200 });
    } catch (err: any) {
        console.error(err);
        return NextResponse.json({ error: err.message }, { status: 500 });
    }
}
